const swaggerAutogen = require('swagger-autogen')({openapi: '3.0.0'})

const outputFile = './swagger_output.json'
const endpointsFiles = ['app.js']


const doc = {
    info: {
        version: "1.0.0",
        title: "BUS RESERVATION",
        description: "Documentation automatically generated by the <b>swagger-autogen</b> module."
    },
    host: "https://redbusbackend11.herokuapp.com",
    basePath: "/",
    schemes: ['http'],
    consumes: ['application/json'],
    produces: ['application/json'],
    tags: [
        {
            "name": "User",
            "description": "APIs to Register and login the users"
        },
        {
            "name": "Bus",
            "description": "APIs to related to bus"
        },
        {
            "name": "Trip",
            "description": "APIs to related to trip"
        },
        {
            "name": "Booking",
            "description": "APIs to related to Bookings"
        }


    ],
    // securityDefinitions: {
    //     api_key: {
    //         type: "apiKey",
    //         name: "api_key",
    //         in: "header"
    //     },
    //     petstore_auth: {
    //         type: "oauth2",
    //         authorizationUrl: "https://petstore.swagger.io/oauth/authorize",
    //         flow: "implicit",
    //         scopes: {
    //             read_pets: "read your pets",
    //             write_pets: "modify pets in your account"
    //         }
    //     }
    // },
    definitions: {

        Register: {
            $name: "Keerthana",
            $mail:"keerthan@gamil.com",
            $password:"keerthana@1106",
            $role:"customer"
        },
        Login:{
            $mail:"keerthan@gamil.com",
            $password:"keerthana@1106" 
        },

        createBus : {
           
            $name:"AHI travels",
            $source:"pune",
            $destination:"mumbai",
            $amount:600,
            $type:"SEMI-SLEEPER",
            $isAC:true,
            $registrationNo :"TNZA323"
    
        

        } ,

        updateBus : {
            $amount : 600,
            $type : "SEMI-SLEEPER",

        },
        addTrip : {
            $name : "AHI travels",
            $source : "coimbatore",
            $destination : "chennai",
            $amount : 400,
            $type : "SEMI-SLEEPER",
            $isAC : true,
            $totalSeats : 32,
            $startDate : "2022-11-22T12:01:00.000Z",
            $endDate  : "2022-11-23T12:30:00.000Z"
        },

        updateTrip : {
            $name : "AHI travels",
            $source : "coimbatore",
            $destination : "chennai",
            $amount : 400,
            $type : "SEMI-SLEEPER",
            $isAC : true,
            $totalSeats : 32,
            $startDate : "2022-11-22T12:01:00.000Z",
            $endDate  : "2022-11-23T12:30:00.000Z"
        },
        RegistrationResponse : {
            message: "User Registration Sucessfull",

        },
        LoginResponse : {
            message : "welcome!!",
            token : "token"

        },

        BusCreateResponse : {
            message: "Bus creation successful",
            id:  "id"
        } ,

        TripCreateResponse : {
                message: "Trip creation successful",
                id: "id"
        },

        GetBusTripsResponse : {
           
                busTrip: [
                    {
                        "_id": "6304727546ca56fc24d1e423",
                        "name": "AHI travels",
                        "source": "coimbatore",
                        "destination": "chennai",
                        "amount": 400,
                        "totalSeats": 32,
                        "bookedSeats": 2,
                        "type": "SEMI-SLEEPER",
                        "isAC": true,
                        "busOperatorId": "62fcc4380f3d8acac84af6ea",
                        "startDate": "2022-09-22T12:01:00.000Z",
                        "endDate": "2022-09-23T12:30:00.000Z",
                        "busId": "630470deb7894ec1f2af6879",
                        "seat": [
                            {
                                "seatNo": 1,
                                "isBooked": true,
                                "_id": "6304727546ca56fc24d1e403"
                            },
                            {
                                "seatNo": 2,
                                "isBooked": true,
                                "_id": "6304727546ca56fc24d1e404"
                            },
                            {
                                "seatNo": 3,
                                "isBooked": false,
                                "_id": "6304727546ca56fc24d1e405"
                            },
                            {
                                "seatNo": 4,
                                "isBooked": false,
                                "_id": "6304727546ca56fc24d1e406"
                            },
                            {
                                "seatNo": 5,
                                "isBooked": false,
                                "_id": "6304727546ca56fc24d1e407"
                            },
                            
                        ]
                    }
                ]
                        
        },
        BusDeleteResponse : {
            message :"deleted the trip "
        },

        TripUpdateResponse : {
            "message":"Successfully Updated!!!"
        } ,

        BookingsResponse : {

            "obj": [
                {
                    "_id": "62ff24362bfa08795427ab12",
                    "user_name": "user4",
                    "user_id": "62fcc4380f3d8acac84af6ea",
                    "bus_id": "62ff1fa88396dc22711df948",
                    "source": "coimbatore",
                    "destination": "chennai",
                    "totalAmount": 800,
                    "noOfSeats": 2,
                    "trip_id": "62ff230d2bfa08795427aa62",
                    "startDate": "2022-08-16T16:00:00.000Z",
                    "endDate": "2022-08-16T18:30:00.000Z",
                    "bus_name": "four travels",
                    "seatNo": [
                        1,
                        2
                    ],
                   
                },
            ]
        }
    }
}
       



swaggerAutogen(outputFile, endpointsFiles,doc).then(() => {
    require('./server.js')
})
